﻿;-
Procedure CountPara(para.s)
  Protected i,inQuote,char.s,count
  If para=""
    ProcedureReturn 0    
  EndIf
  
  count=1
  For i=1 To Len(para)
    char=Mid(para,i,1)
    If inQuote
      If char=#DQUOTE$
        inQuote=#False
      EndIf
    Else
      If char=#DQUOTE$
        inQuote=#True
      ElseIf char=","
        count+1
      EndIf
    EndIf
  Next
  ProcedureReturn count
EndProcedure
Structure Paralist
  name.s
  type.s
  optional.s
EndStructure

Procedure SplitPara(para.s,Array ParaList.Paralist(1))
  Protected count
  Protected i,inQuote,char.s,pos,inType,inOptional
  count=CountPara(para)
  Dim Paralist(count)
  If count=0
    ProcedureReturn 0
  EndIf
  Debug "--SPLITPARA---"
  Debug Para
  pos=1
  For i=1 To Len(para)
    char=Mid(para,i,1)
    If inQuote
      If char=#DQUOTE$
        inQuote=#False
      EndIf
      If inOptional
        Paralist(pos)\optional+char
      EndIf
    Else
      Select char
        Case #DQUOTE$
          inQuote=#True
          If inOptional
            Paralist(pos)\optional+char
          EndIf
        Case "."
          inType=#True
        Case "="
          inOptional=#True
        Case ","
          inType=#False
          inOptional=#False
          pos+1
        Default
          If inOptional
            Paralist(pos)\optional+char
          ElseIf inType
            Paralist(pos)\type+char
          Else
            Paralist(pos)\name+char
            If char="$"
              inType=#True
            EndIf
          EndIf
      EndSelect
    EndIf
  Next
  For i=1 To count
     Debug i
     Debug "  "+Paralist(i)\name
     Debug "  "+paralist(i)\optional
     Debug "  "+Paralist(i)\type
    Paralist(i)\name=Trim(Paralist(i)\name)
    Paralist(i)\optional=Trim(Paralist(i)\optional)
    Paralist(i)\type=Trim(Paralist(i)\type)
  Next
 Debug "-----" 
  ProcedureReturn count
EndProcedure

Global NewMap RenameProc.s()    
Procedure.s FindRenameProc(name.s)
  If FindMapElement(RenameProc(),LCase(name))
    ProcedureReturn RenameProc()
  Else
    ProcedureReturn name
  EndIf
EndProcedure
Procedure.s RenameLine(line.s)
  Protected name.s
  Protected pos,pos2,pos3,pos4,ColonCount

  pos=0
  Repeat
    pos=FindString(line,"(",pos+1)
    If pos=0
      Break
    EndIf
    pos2=pos-1
    While pos2>0 And Mid(line,pos2,1)=" "
      pos2-1
    Wend
    pos3=pos2
    While pos3>0 And FindString("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ_", Mid(line,pos3,1),1,#PB_String_NoCase)>0
      pos3-1
    Wend
    pos3+1
    
    pos4=pos3-1
    ColonCount=0
    While pos4>0 And ColonCount<2 And FindString(" :",Mid(line,pos4,1))>0
      If Mid(line,pos4,1)=":"
        ColonCount+1
      EndIf
      pos4-1
    Wend
    
    If ColonCount<2 And 0<pos3 And pos3<pos2 And pos2<pos 
      name=Mid(line,pos3,pos2-pos3+1)
      
      If FindMapElement(RenameProc(),LCase(name))
        line=Left(line,pos3-1)+RenameProc()+Mid(line,pos2+1)
        pos-Len(name)+Len(RenameProc())
      EndIf
    EndIf    
    
  ForEver
  ProcedureReturn line
EndProcedure
; Procedure.s renameASMLine(line.s)
;   Protected pos=0,pos2,name.s
;   Repeat
;     pos=FindString(line,#asm_ProcLabel,pos+1)
;     If pos=0
;       Break
;     EndIf
;     pos2=pos+Len(#asm_ProcLabel)
;     While FindString("0123456789", Mid(line,pos2,1))>0
;       pos2+1
;     Wend
;     pos2-1
;     
;     If pos2>0 And pos2>pos
;       name=Mid(line,pos,pos2-pos+1)
;             
;       If FindMapElement(RenameProc(),name)
;         line=Left(line,pos-1)+RenameProc()+Mid(line,pos2+1)
;         pos-Len(name)+Len(RenameProc())
;       EndIf
;     EndIf
;   ForEver
;   ProcedureReturn line
; EndProcedure

Procedure FindExportDLL(name.s)
  Protected ret=#True
  name.s=LCase(name)
  ForEach ExportDLL()
    If LCase(ExportDLL()\name)=name
      ret=#True:Break
    EndIf
  Next
  ProcedureReturn ret
EndProcedure


  
Procedure CreateLib()
  Protected line.s
  Protected inExport=0,inMacro=0,inModule=0,inExportModule=0
  Protected type.s,name.s,para.s,orgline.s,word.s
  Protected inClassInterface=0,inClassStructure=0
  Protected count,opt,i
  Protected shortlibname.s=GetFilePart(OriginalMainFile,#PB_FileSystem_NoExtension)
  Dim paralist.Paralist(0)
  
  CreateLogFile(ExecuteFile+".log")
  
  InfoText("CreateLib - PreProcess")
  
  ClearMap(RenameProc())
  ;{ Build Rename-map
  CompilerIf #LibType=#LibStatic
    ForEach exportdll()
      With exportdll()
        If LCase(\name)=LCase(shortlibname+"init") Or LCase(\name)=LCase(shortlibname+"exit")
          DeleteElement(ExportDLL())
        Else
          
          count=SplitPara( SimplePara( \para,#True), paralist())
          If Paralist(count)\optional<>""
            opt=0
            For i=1 To count
              If Paralist(count)\optional<>""
                opt+1
              EndIf
            Next
            If Paralist(1)\optional<>""
              opt+1
            EndIf
            
            ;opt-1
            RenameProc(LCase(\name))=\name + opt  
            \maxopt=opt
          EndIf
          
        EndIf
        
      EndWith
    Next
  CompilerElse
    ForEach exportdll()
      With exportdll()
        RenameProc(LCase(\name))=#Export_Name+ \name    
      EndWith
    Next
  CompilerEndIf
  ;}
    
  ;{ create preprocess
  If Program(PBCompiler, 
             #DQUOTE$+CompilerInputFile+#DQUOTE$+
             " "+#flag_PreProcess+" "+#DQUOTE$+tempfile+#DQUOTE$+
             CompilerFlags+" "+#flag_Constant+" __PreCompilerPreProcess__=1", 
             GetPathPart(PBCompiler))
    
    CreateErrorLine(LibErrorFile,"Cant PreProcess Lib:"+#LineEnd+programOutput)
    End
  EndIf
  ;}
  
  ;{ Parse preprocessed lib
  Protected in,pos,pos2,ClassName.s,ModuleName.s
  Protected subpara.s
  Protected subpara2.s
  Protected ignorerestcommend
  InfoText("CreateLib - Parse file")
  
  in=MyReadFile(#PB_Any,tempfile)
  If in=0
    CreateErrorLine(LibErrorFile,"Can't open tempfile"+#LineEnd+tempfile)
    End
  EndIf
  
  ClearList(CompleteFile())
  NewList XIncludeHeader.s()
  
  While Not Eof(in)
    InfoLoop()
    orgline=Trim(ReadString(in))
    line=orgline
    While Right(line,1)=":" : line=Trim(Left(line,Len(line)-1)) : Wend
    While FindString(line,"  ") : line=ReplaceString(line,"  "," ") : Wend
    
    word=StringField(StringField(line,1," "),1,".")
    If Left(line,1)=";";kommentare 
      If inMacro=#False And inModule=#False And inExport=#False And inClassInterface=#False And inClassStructure=#False
        pos=ReturnSecondCommend(orgline)
        If pos
          line=Mid(orgline,pos)
          If line<>";-**** MainFile ****"
            If Left(line,15)="; IDE Options ="
              ignorerestcommend=#True
            EndIf
            If ignorerestcommend=#False
              AddElement(CompleteFile())
              CompleteFile()=line
            EndIf
          EndIf
            
        EndIf
      EndIf
      
      
    ElseIf inMacro=0 And Left(word,23)="#__PreCompilerCommand__" ;- ....PreCompilerCommand
      pos=FindString(line,#DQUOTE$)
      line=Mid(line,pos+1,Len(line)-1-pos)
      word=StringField(line,1," ")
      Select word
        Case "ExportStart":inExport=#True
        Case "ExportEnd":inExport=#False
      EndSelect
    Else
      
      If inExportModule
        AddElement(ExportModuleMap()\source())
        ExportModuleMap()\source()=orgline  
      EndIf
      
      Select LCase(word)
        Case "structure";- ....Structure
          If inMacro=#False And inModule=#False And inExport=#False
            pos=11
            While Mid(line,pos,1)=" ":pos+1:Wend
            pos2=FindString(line," ",pos):If pos2=0:pos2=Len(line)+1:EndIf
            ClassName=LCase(Mid(line,pos,pos2-pos))
            If Left(ClassName,1)="s"
              ClassName=Mid(ClassName,2)
              If FindExportClass(ClassName)
                inClassStructure=#True
              EndIf
            EndIf
            If inClassStructure=#False
              AddElement(CompleteFile())
              CompleteFile()=orgline
            EndIf
          EndIf
          
        Case "endstructure";- ....EndStructure
          If inMacro=#False And inModule=#False And inExport=#False
            If inClassStructure
              inClassStructure=#False
            Else          
              AddElement(CompleteFile())
              CompleteFile()=orgline
            EndIf
          EndIf
          
        Case "interface";- ....Interface
          If inMacro=#False And inModule=#False And inExport=#False
            pos=11
            While Mid(line,pos,1)=" ":pos+1:Wend
            pos2=FindString(line," ",pos):If pos2=0:pos2=Len(line)+1:EndIf
            ClassName=LCase(Mid(line,pos,pos2-pos))
            If FindExportClass(ClassName)
              inClassInterface=#True
            EndIf
            If inClassInterface=#False
              AddElement(CompleteFile())
              CompleteFile()=orgline
            EndIf
          EndIf
          
        Case "endinterface";- ....EndInterface
          If inMacro=#False And inModule=#False And inExport=#False
            If inClassInterface
              inClassInterface=#False
            Else
          
              AddElement(CompleteFile())
              CompleteFile()=orgline
            EndIf
          EndIf          
                  
        Case "proceduredll", "procedurecdll","declaredll","declarecdll";- ....Proceduredll/declaredll
          If inMacro=#False And inModule=#False And inExport=#False
            pos=Len(word)+1
            While Mid(line,pos,1)<>" ":pos+1:Wend
            type=Mid(line,Len(word)+1,pos-Len(word)-1)
            While Mid(line,pos,1)=" ":pos+1:Wend
            pos2=FindString(line,"(")
            
            name=Trim(Mid(line,pos,pos2-pos))
            para=Trim(Mid(line,pos2))
                      
            CompilerIf #LibType=#LibInclude
              AddElement(CompleteFile())
              CompleteFile()=Left(word,Len(word)-3)+type+" "+#Export_Name+name+para ;Remove DLL and change name
            CompilerElse
              ;{
              If FindExportDLL(name)
                With ExportDLL()
                  If Left(LCase(word),9)="procedure"
                    If \maxopt
                      count= SplitPara( SimplePara(para,#True),paralist())
                      
                      AddElement(CompleteFile())
                      CompleteFile()=ReplaceString(word,"procedure","declare",#PB_String_NoCase)+type+" "+name+ \maxopt +para
                    
                      subpara="":subpara2=""
                      opt=1
                      For i=1 To count
                        If Paralist(i)\optional<>""
                          If opt>1
                            AddElement(CompleteFile()):CompleteFile()=word+type+" "+name+opt+"("+subpara+")"
                          Else
                            AddElement(CompleteFile()):CompleteFile()=word+type+" "+name+"("+subpara+")"
                          EndIf                          
                          AddElement(CompleteFile()):CompleteFile()="  ProcedureReturn "+name+ \maxopt+"("+subpara2+")"
                          AddElement(CompleteFile()):CompleteFile()="EndProcedure"
                          opt+1
                        EndIf
                        If i>1 : subpara+"," : subpara2+",": EndIf
                        subpara+ Paralist(i)\name+"."+Paralist(i)\type
                        If FindString(Paralist(i)\name," ")
                          subpara2+StringField(Paralist(i)\name,2," ")+"."+Paralist(i)\type
                        Else
                          subpara2+ Paralist(i)\name+"."+Paralist(i)\type
                        EndIf
                      Next
                      AddElement(CompleteFile()):CompleteFile()=word+type+" "+name+ \maxopt +para
                    Else
                      AddElement(CompleteFile()):CompleteFile()=word+type+" "+name +para
                    EndIf
                  Else
                    If \maxopt
                      AddElement(CompleteFile()):CompleteFile()=word+type+" "+name+ \maxopt +para
                    Else
                      AddElement(CompleteFile()):CompleteFile()=word+type+" "+name +para
                    EndIf
                  EndIf
                EndWith
              EndIf
              ;}
            CompilerEndIf
            
          EndIf
        
        Case "macro" ;- ....Macro
          inMacro=#True
          
        Case "endmacro";- ....EndMacro
          inMacro=#False
          
        Case "module";- ....Module
          If inMacro=#False
            inModule=#True
            pos=6+2
            While Mid(line,pos,1)=" ":pos+1:Wend
            pos2=FindString(line," ",pos):If pos2=0:pos2=Len(line)+1:EndIf
            ModuleName=Mid(line,pos,pos2-pos)
            
            If FindMapElement(ExportModuleMap(),LCase(ModuleName))
              If ExportModuleMap()\doIgnore=#False
                inExportModule=#True
                AddElement(ExportModuleMap()\source())
                ExportModuleMap()\source()=orgline
              EndIf
            EndIf
          EndIf 
          
        Case "endmodule","enddeclaremodule";- ....EndModule
          If inMacro=#False
            inModule=#False
            inExportModule=#False
          EndIf
          
        Case "declaremodule";- ....DeclareModule
          If inMacro=#False
            inModule=#True
            pos=15
            While Mid(line,pos,1)=" ":pos+1:Wend
            pos2=FindString(line," ",pos):If pos2=0:pos2=Len(line)+1:EndIf
            ModuleName=Mid(line,pos,pos2-pos)
            If ModuleName<>"_PreCompiler_" 
              If FindMapElement(ExportModuleMap(),LCase(ModuleName))
                AddElement(XIncludeHeader())
                XIncludeHeader()="XIncludeFile "+#DQUOTE$+PreCompilerHome+CompilerOsBin+"_"+LCase(ModuleName)+".Module";.pbi"+#DQUOTE$
                                
                If ExportModuleMap()\doIgnore=#False
                  inExportModule=#True
                  AddElement(ExportModuleMap()\source())
                  ExportModuleMap()\source()=orgline
                EndIf
                
              Else
                AddElement(XIncludeHeader())
                XIncludeHeader()="XIncludeFile "+#DQUOTE$+PreCompilerHome+ModuleName;+".pbi"+#DQUOTE$
                
                If FileSize(PreCompilerHome+ModuleName+".declare.pbi")<=0
                  CreateErrorLine(LibErrorFile,"Module is forbidden!"+#LineEnd+ModuleName)
                  End
                EndIf
              EndIf
              
              
            EndIf
          EndIf
          
        Default;- ....Default
          If inMacro=#False And inModule=#False And inExport=#False And inClassInterface=#False And inClassStructure=#False
            AddElement(CompleteFile())
            CompleteFile()=RenameLine(orgline)
          EndIf
      EndSelect
    EndIf
  Wend
  
  CloseFile(in)
  ;}
  

  ;{ Create/save Lib
  Protected out,proc.s
  
  If ListSize(ExportDLL())>0
    CompilerIf #LibType=#LibInclude
      ;-..Include
      
      ;-....Declare-Part
      out=MyCreateFile(#PB_Any,ExecuteFile+".declare.pbi")
      If out=0
        CreateErrorLine(LibErrorFile,"Can't create "+ExecuteFile+".declare.pbi")
        End
      EndIf
      
      ;Header
      WriteStringN(out,";Generated by "+#title)
      WriteStringN(out, "CompilerIf Not Defined(_"+libname+"_declare_,#PB_Constant)" )
      WriteStringN(out, "#_"+libname+"_declare_=#true")
        
      ForEach XIncludeHeader()
        WriteStringN(out,XIncludeHeader()+".declare.pbi"+#DQUOTE$)
      Next  
      
      WriteStringN(out,"DeclareModule "+libname)
      WriteStringN(out,";-**** DeclareModule "+libname+" ****")

      ;Mark needed Res-File
      WriteStringN(out,"#__PreCompilerCommand__Manuell1="+#DQUOTE$+"AddResFile "+libname+".res.pb"+#DQUOTE$)
      
      ForEach ExportDLL()
        With ExportDLL()
          proc=LCase(\name)
          If proc<>"attachprocess" And proc<>"detachprocess" And proc<>"attachthread" And proc<>"detachthread"
            WriteStringN(out,"Declare"+\typ+" "+#Export_Name+\name+"("+ SimplePara(\para,#True)+")" )
          EndIf
        EndWith    
      Next  
      
      WriteStringN(out,";Exported Class")
      ForEach ExportLibDeclare()
        WriteStringN(out,ExportLibDeclare())
      Next
      
      WriteStringN(out,";-**** EndDeclareModule ****")
      WriteStringN(out,"EndDeclareModule")
      WriteStringN(out,"CompilerEndif")
      CloseFile(out)
      
      ;-....define-Part
      
      out=MyCreateFile(#PB_Any,ExecuteFile+".define.pbi")
      If out=0
        CreateErrorLine(LibErrorFile,"Can't create "+ExecuteFile+".define.pbi")
        End
      EndIf
      
      ;Header
      WriteStringN(out, "CompilerIf Not Defined(_"+libname+"_define_,#PB_Constant)" )
      WriteStringN(out, "#_"+libname+"_define_=#true")
      WriteStringN(out,";Generated by "+#title)
      
      
      ForEach XIncludeHeader()
        WriteStringN(out,XIncludeHeader()+".define.pbi"+#DQUOTE$)
      Next  
      
      WriteStringN(out,"Module "+libname)
      WriteStringN(out,";-**** Module "+libname+" ****")
      ForEach CompleteFile()
        WriteStringN(out,CompleteFile())
      Next  
      WriteStringN(out,";-**** EndModule ****")
      WriteStringN(out,"EndModule")
      
      WriteStringN(out,"CompilerEndIf")
      
      CloseFile(out)
    CompilerElse
      ;-..Static
      out=MyCreateFile(#PB_Any,ExecuteFile+".pb")
      If out=0
        CreateErrorLine(LibErrorFile,"Can't create "+ExecuteFile+".pb")
        End
      EndIf
      ;Header
      WriteStringN(out,";User-Library from "+#title)
      
      WriteStringN(out,";-Include UserLibraries")
      ForEach XIncludeHeader()
        WriteStringN(out,XIncludeHeader()+".declare.pbi"+#DQUOTE$)
      Next  
      
      ForEach XIncludeHeader()
        WriteStringN(out,XIncludeHeader()+".define.pbi"+#DQUOTE$)
      Next  
      
      WriteStringN(out,";-Resources")
      WriteStringN(out,";-..ExportedClass")
      WriteStringN(out,";Exported Class")
      ForEach ExportClassList()
        class("::"+UCase(ExportClassList()))
        WriteStringN(out,"Interface " + ExportClassList())
        ForEach class()\method()
          With class()\method()
            If \isSpecial=#False 
              WriteStringN(out, \name + \typ +
                                "("+ 
                                SimplePara(\para,#True)+
                                ")")
            EndIf
          EndWith
        Next
        WriteStringN(out,"EndInterface")
        WriteStringN(out,"Structure s"+ExportClassList())
        ForEach class()\struc()
          WriteStringN(out,class()\struc())
        Next
        WriteStringN(out,"EndStructure")
      Next
      
      WriteStringN(out,";-..Exported Resources")
      inMacro=#False
      ForEach AddResourceFile()
        line=AddResourceFile()
        While Right(line,1)=":" : line=Trim(Left(line,Len(line)-1)) : Wend
        While FindString(line,"  ") : line=ReplaceString(line,"  "," ") : Wend
        
        word=LCase(StringField(StringField(line,1," "),1,"."))
        
        If inMacro=#False
          If word="macro"
            inMacro=#True
          Else
            WriteStringN(out,AddResourceFile())
          EndIf
        ElseIf word="endmacro"
          inMacro=#False
        EndIf
      Next
      
      WriteStringN(out,";-Exported Class")
      ForEach ExportLibDeclare()
        WriteStringN(out,ExportLibDeclare())
      Next
      
      WriteStringN(out,";-Exported Function")
      ForEach ExportDLL()
        With ExportDLL()
          If \maxopt=0
            WriteStringN(out,"Declare"+Left("C",\isCDECL)+"DLL"+\typ+" "+ \name +" "+\para+" ; - "+\desc )
          Else
            WriteStringN(out,"Declare"+Left("C",\isCDECL)+"DLL"+\typ+" "+ \name + \maxopt +" "+\para+" ; - "+\desc )
          EndIf
        EndWith
      Next
      
      WriteStringN(out,";-Complete Userlib")
      
      ForEach CompleteFile()
        WriteStringN(out,CompleteFile())
      Next  
      
      name=shortlibname
      
      WriteStringN(out,";-Init/Exit")
      WriteStringN(out,"ProcedureDLL __"+libname+"_INIT__()")
      WriteStringN(out,"  #__precompiler__init = 0")
      WriteStringN(out,"  CompilerIf Defined("+name+"Init,#PB_Procedure)")
      WriteStringN(out,"    "+name+"Init()")
      WriteStringN(out,"  CompilerEndif")
      WriteStringN(out,"EndProcedure")
      
      WriteStringN(out,"ProcedureDLL __"+libname+"_EXIT__()")
      WriteStringN(out,"  CompilerIf Defined("+name+"Exit,#PB_Procedure)")
      WriteStringN(out,"    "+name+"Exit()")
      WriteStringN(out,"  CompilerEndif")
      WriteStringN(out,"EndProcedure")
      
      CloseFile(out)
      
      
    CompilerEndIf
    
    
  EndIf
  ;}
  
    
  CompilerIf #LibType=#LibStatic
    XIncludeFile "createasm.pbi"
  CompilerEndIf

  
  ;{ Create module.pbi
  ForEach ExportModuleMap()
    If ListSize( ExportModuleMap()\source() ) And ExportModuleMap()\doIgnore=#False
      out=MyCreateFile(#PB_Any,PreCompilerHome+CompilerOsBin+"_"+MapKey( ExportModuleMap() )+".module.declare.pbi")
      
      If out=0
        CreateErrorLine(LibErrorFile, "could not export "+CompilerOsBin+"_"+MapKey( ExportModuleMap() )+".module.declare.pbi")
        End
      EndIf
      
      WriteStringN(out,";Exported from "+OriginalMainFile)
      ForEach ExportModuleMap()\source()
        If LCase(Left(ExportModuleMap()\source(),7))="module "
          CloseFile(out)
          out=MyCreateFile(#PB_Any,PreCompilerHome+CompilerOsBin+"_"+MapKey( ExportModuleMap() )+".module.define.pbi")
          
          If out=0
            CreateErrorLine(LibErrorFile, "could not export "+CompilerOsBin+"_"+MapKey( ExportModuleMap() )+".module.define.pbi")
            End
          EndIf
          WriteStringN(out,";Exported from "+OriginalMainFile)
        EndIf        
        WriteStringN(out, ExportModuleMap()\source() )
      Next
      CloseFile(out)
    EndIf
  Next 
  ;}
  
   
  ;{ Create Res
  If (ListSize(exportdll())>0 And #LibType=#LibInclude) Or ListSize(ExportClassList())>0 Or ListSize(AddResourceFile())>0
    InfoText("Create Resident")
    out= MyCreateFile(#PB_Any,ExecuteFile+".res.pb")
    If out=0
      CreateErrorLine(LibErrorFile,"Can't create res.pb."+#LineEnd+ExecuteFile+".res.pb")
      End    
    EndIf
    
    CompilerIf #LibType=#LibInclude
      WriteStringN(out,";Exported Procedures")
      ForEach ExportDLL()
        With ExportDLL()
          proc=LCase(\name)
          If proc<>"attachprocess" And proc<>"detachprocess" And proc<>"attachthread" And proc<>"detachthread"
            WriteStringN(out,"Macro "+ \name +"("+ SimplePara(\para,#True,#True) +")"+#LineEnd+
                             "  "+libname+"::"+#Export_Name+ \name + "("+SimplePara(\para,#False,#True)+")"+#LineEnd+
                             "EndMacro")
          EndIf
        EndWith    
      Next
   CompilerEndIf
    
    WriteStringN(out,";Exported Class")
    ForEach ExportClassList()
      class("::"+UCase(ExportClassList()))
      WriteStringN(out,"Interface " + ExportClassList())
     
      ForEach class()\method()
        With class()\method()
          If \isSpecial=#False 
            WriteStringN(out, \name + \typ +
                              "("+ 
                              SimplePara(\para,#True)+
                              ")")
          EndIf
          
        EndWith
      Next
      WriteStringN(out,"EndInterface")
      WriteStringN(out,"Structure s"+ExportClassList())
      ForEach class()\struc()
        WriteStringN(out,class()\struc())
      Next
      WriteStringN(out,"EndStructure")
      WriteStringN(out,class()\namelist)
      WriteStringN(out,class()\paralist)
      
    Next
    
    WriteStringN(out,";Exported Resources")
    ForEach AddResourceFile()
      WriteStringN(out,AddResourceFile())
    Next
    
    CloseFile(out)
    
    If program(PBCompiler,
               #DQUOTE$+ExecuteFile+".res.pb"+#DQUOTE$+
               " "+#flag_Quiet+" "+
               " "+#flag_IgnoreResident+" "+#DQUOTE$+libname+".res"+#DQUOTE$+
               " "+#flag_Resident+" "+
               #DQUOTE$+PBHome+#path_residents+libname+".res"+#DQUOTE$,
               GetPathPart(ExecuteFile))<>0
      CreateErrorLine(LibErrorFile,"Can't create res."+#LineEnd+programOutput)
      End
    EndIf
  EndIf
  ;}
  
  ;{ Create info
  Protected *vtlink.method,vtstring.s
  
  If ListSize(ExportClassList())>0
    out=MyCreateFile(#PB_Any,ExecuteFile+".info")
    If out=0
      CreateErrorLine(LibErrorFile,"Can't create info."+#LineEnd+ExecuteFile+".info")
      End    
    EndIf
   ForEach ExportClassList()
     class("::"+UCase(ExportClassList()))   
     
     WriteStringN(out,"ClassName="+ExportClassList())
     WriteStringN(out,"Extends="+class()\extends)
     
     i=0
     ForEach class()\method()
       If class()\method()\vt<>"" Or class()\method()\isSpecial=#False
         i+1
       EndIf
     Next
     
     WriteStringN(out,"MethodsSize="+i )
     ForEach class()\method()
       
       If class()\method()\vt<>"" Or class()\method()\isSpecial=#False
         *vtlink=class()\method()
         
         ;search VT from parent if neccassery
         While *vtlink\vt="" And *vtlink\VTlink
           *vtlink=*vtlink\VTlink
         Wend      
         If *vtlink\vt<>""
           vtstring=*vtlink\vt
           If FindString(vtstring,"::")=0 And vtstring<>"#Null"
             vtstring=libname+"::"+vtstring
           EndIf          
         Else
           vtstring=""
         EndIf
         
         WriteStringN(out,"Name="+class()\method()\name)
         WriteStringN(out,"Para="+class()\method()\para)
         WriteStringN(out,"typ="+class()\method()\typ)
         WriteStringN(out,"VT="+vtstring)
         WriteStringN(out,"IsSpecial="+class()\method()\isSpecial)
       EndIf
     Next
     WriteStringN(out,"StructureSize="+ListSize(class()\struc()))
     ForEach class()\struc()
       WriteStringN(out,"Element="+class()\struc())
     Next
   Next
      
   CloseFile(out)
    
  EndIf
  ;}
  

EndProcedure
; IDE Options = PureBasic 5.61 (MacOS X - x64)
; CursorPosition = 569
; FirstLine = 477
; Folding = --+-
; EnableXP