﻿Global lastGadgetHeight
Procedure gMultiText(x,y,width,Text.s,flags=0)
  Protected gad,needwidth,needHeight
  Protected count
  Protected i
  Protected pos=0,oldpos=0,startpos=1
  lastGadgetHeight=0
  gad=TextGadget(#PB_Any,x,y,width,10,"a",flags)
  text+" "
  Repeat
    oldpos=pos
    pos=FindString(text," ",pos+1)
    If pos=0 
      Break
    EndIf
    
    SetGadgetText(gad,Mid(text,startpos,pos-startpos))
    ;Debug ""+startpos+" "+pos+" "+Mid(text,startpos,pos-startpos)
    
    needwidth=GadgetWidth(gad,#PB_Gadget_RequiredSize)
    If needwidth>width
      SetGadgetText(gad,Mid(text,startpos,oldpos-startpos))
      needHeight=GadgetHeight(gad,#PB_Gadget_RequiredSize)
      ResizeGadget(gad,#PB_Ignore,#PB_Ignore,#PB_Ignore,needHeight)
      lastGadgetHeight+needHeight
      y+needHeight
      
      startpos=oldpos+1
      pos=oldpos
      gad=TextGadget(#PB_Any,x,y,width,10,"a",flags)
    EndIf
  ForEver
  needHeight=GadgetHeight(gad,#PB_Gadget_RequiredSize)
  ResizeGadget(gad,#PB_Ignore,#PB_Ignore,#PB_Ignore,needHeight)
  lastGadgetHeight+needHeight
  
  ProcedureReturn lastGadgetHeight
EndProcedure
Procedure gString(x,y,width,text.s,flags=0)
  Protected gad
  gad=StringGadget(#PB_Any,x,y,width,10,text,flags)
  If width=0
    width=GadgetWidth(gad,#PB_Gadget_RequiredSize)
  EndIf
  ResizeGadget(gad,#PB_Ignore,#PB_Ignore,width,GadgetHeight(gad,#PB_Gadget_RequiredSize))
  ProcedureReturn gad
EndProcedure
Procedure gText(x,y,width,text.s,flags=0)
  Protected gad
  gad=TextGadget(#PB_Any,x,y,width,10,text,flags)
  If width=0
    width=GadgetWidth(gad,#PB_Gadget_RequiredSize)
  EndIf
  ResizeGadget(gad,#PB_Ignore,#PB_Ignore,width,GadgetHeight(gad,#PB_Gadget_RequiredSize))
  ProcedureReturn gad
EndProcedure
Procedure gCheckbox(x,y,width,text.s,flags=0)
  Protected gad
  gad=CheckBoxGadget(#PB_Any,x,y,width,10,text,flags)
  If width=0
    width=GadgetWidth(gad,#PB_Gadget_RequiredSize)
  EndIf
  ResizeGadget(gad,#PB_Ignore,#PB_Ignore,width,GadgetHeight(gad,#PB_Gadget_RequiredSize))
  ProcedureReturn gad
EndProcedure
Procedure gButton(x,y,width,text.s,flags=0)
  Protected gad
  gad=ButtonGadget(#PB_Any,x,y,width,10,text,flags)
  If width=0
    width=GadgetWidth(gad,#PB_Gadget_RequiredSize)
  EndIf
  ResizeGadget(gad,#PB_Ignore,#PB_Ignore,width,GadgetHeight(gad,#PB_Gadget_RequiredSize))
  ProcedureReturn gad
EndProcedure
Procedure gVCenter(gad,height)
  Protected needHeight
  needHeight=GadgetHeight(gad,#PB_Gadget_RequiredSize)
  If height<>needHeight
    ResizeGadget(gad,#PB_Ignore, GadgetY(gad) + (height-needHeight)/2,#PB_Ignore,#PB_Ignore)
  EndIf
EndProcedure
Procedure gvMultiCenter(gad1,gad2,gad3=0,gad4=0)
  Protected hh,h
  hh=GadgetHeight(gad1)
  h=GadgetHeight(gad2):If h>hh:hh=h:EndIf
  If gad3
    h=GadgetHeight(gad3):If h>hh:hh=h:EndIf
  EndIf
  If gad4
    h=GadgetHeight(gad4):If h>hh:hh=h:EndIf
  EndIf
  
  gVCenter(gad1,hh)
  gVCenter(gad2,hh)
  If gad3
    gVCenter(gad3,hh)
  EndIf
  If gad4
    gVCenter(gad4,hh)
  EndIf  
  ProcedureReturn hh
EndProcedure
Procedure gRightAlign(gad,width)
  ResizeGadget(gad,GadgetX(gad)+width-GadgetWidth(gad),#PB_Ignore,#PB_Ignore,#PB_Ignore)
  ProcedureReturn gad
EndProcedure

Structure key
  key.s
  value.s
EndStructure
Structure group
  List key.key()
EndStructure


Procedure RemoveToolPrefs(ToolPrefs.s,deletecommand.s)
  Protected count,i
  NewList pref.group()
  
  If OpenPreferences(ToolPrefs)
    PreferenceGroup("ToolsInfo")
    count=ReadPreferenceLong("ToolCount",0)
    
    For i=0 To count-1
      AddElement(pref())
      PreferenceGroup("Tool_"+i)
      If ExaminePreferenceKeys()
        While NextPreferenceKey()
          AddElement(pref()\key())
          pref()\key()\key=PreferenceKeyName()
          pref()\key()\value=PreferenceKeyValue()
          If pref()\key()\value=deletecommand
            DeleteElement(pref())
            Break
          EndIf
        Wend
      EndIf
    Next
    
    PreferenceGroup("ToolsInfo")
    WritePreferenceLong("ToolCount", ListSize(pref()))
    ForEach pref()
      PreferenceGroup("Tool_"+ListIndex(pref()))
      ForEach pref()\key()
        WritePreferenceString(pref()\key()\key,pref()\key()\value)
      Next
    Next
    
    For i=ListSize(pref()) To count-1
      RemovePreferenceGroup("Tool_"+i)
    Next
    ClosePreferences()    
  EndIf  
  
EndProcedure


Procedure InstallScript(mainfile.s)
  CompilerIf #userdir
    Protected appdataPB.s=GetUserDirectory(#userdir)+#pbSettingsPath
  CompilerElse
    Protected appdataPB.s=GetHomeDirectory()+#pbSettingsPath
  CompilerEndIf
  
  Protected ToolPrefs.s=appdataPB+#pbToolsPref
  Protected PureBasicPrefs.s=appdataPB+#pbPurebasicPrefs
  Protected execute.s,workdir.s
  

  
  
  CompilerIf #PB_Compiler_Debugger ;And #False ;----------------------
    MessageRequester(#title,"Welcome to the PreCompiler Quick-Setup"+#LineEnd+
                            "First we compile the PreCompiler. I suggest to select an empty directory!"+#LineEnd+
                            "Then the setup will restart!"+#LineEnd)
    
    
    InfoText("Create PreCompiler"+#ExtExe)
    execute=GetPathPart(mainfile)+"PreCompiler"+#ExtExe
    execute=SaveFileRequester(#title + " - Create PreCompiler"+#ExtExe,execute,"execute|*"+#ExtExe+"|All files|*.*",0)
    If execute=""
      End
    EndIf
    If program(#PB_Compiler_Home+#pb_compiler,#DQUOTE$+mainfile+#DQUOTE$+" "+#flag_Quiet+" "+#flag_Execute+" "+#DQUOTE$+execute+#DQUOTE$,GetPathPart(#PB_Compiler_Home+#pb_compiler))
      MessageRequester(#title,"Can't compile mainfile"+#LineEnd+mainfile+#LineEnd+programOutput)
      End
    EndIf
    CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
      ;Debug execute+"/Contents/PreCompiler.ini"
      OpenPreferences(execute+"/Contents/PreCompiler.ini")
      WritePreferenceString("WorkingDir",GetPathPart(execute))
      ClosePreferences()
      execute+ "/Contents/MacOS/"+GetFilePart(execute,#PB_FileSystem_NoExtension)
    CompilerEndIf
    
    RunProgram(execute)
    
    CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
      MessageRequester(#title,"Please close the PureBasic IDE."+#LineEnd+"The Setup is behind the IDE!")
    CompilerEndIf
    
    End
    
  CompilerEndIf
  
  execute=ProgramFilename()
  
  CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Windows
      workdir=GetPathPart(execute)
    CompilerCase #PB_OS_MacOS
      Protected inifile.s
      workdir=GetPathPart(execute)
      workdir=GetPathPart(Left(workdir,Len(workdir)-1))
      workdir=GetPathPart(Left(workdir,Len(workdir)-1))
      workdir=GetPathPart(Left(workdir,Len(workdir)-1))
      inifile=GetCurrentDirectory()+"PreCompiler.ini"      
     
    CompilerDefault
      workdir=GetPathPart(execute)
  CompilerEndSelect
  
  Protected win,height,width,gad,leftside,rightside,needHeight,leftStart,rightStart,h1,h2
  Protected lPBCompiler,tPBCompiler,bPBCompiler
  Protected cCreateLib
  Protected lWorkdir,tWorkdir,bWorkdir
  Protected cTools,tTools,bTools
  Protected cIde,tIde,bIde
  Protected bInstall,bCancel
  Protected bdeinstall
  
  win=OpenWindow(#PB_Any,0,0,600,600,#title+" - Quick Setup",#PB_Window_Invisible|#PB_Window_ScreenCentered|#PB_Window_SystemMenu)
  If win=0
    MessageRequester(#title,"Can't open window!")
    End
  EndIf
  
  width=WindowWidth(win)
  height=5
  
  height+GadgetHeight(gText(5,height,width-10,"Welcome to the Quick Setup!"))
  height+5
  height+gMultiText(5,height,width-10,"Please close the PureBasic IDE before you continue. "+
                                      "You need to create the IncludeLibraries for every PBCompiler you want to use. "+
                                      "I recommend to set the PreCompiler working directory to a empty directory. "+
                                      "Precompiler will store every IncludeLibrary there.")
  height+5
  leftside=(width-10)*1/3:leftStart=5
  rightside=(width-10)-leftside:rightStart=leftStart+leftside
  
  bPBCompiler=gRightAlign(gButton(rightStart,height,0,"..."),rightside)  
  lPBCompiler=gText(leftStart,height,leftside,"PBCompiler")
  tPBCompiler=gString(rightStart,height,rightside-GadgetWidth(bPBCompiler),#PB_Compiler_Home+#pb_compiler)
  height+gvMultiCenter(lPBCompiler,tPBCompiler,bPBCompiler)
  
  bWorkdir=gRightAlign(gButton(rightStart,height,0,"..."),rightside)  
  lWorkdir=gText(leftStart,height,leftside,"PreCompiler Working Directory")
  tWorkdir=gString(rightStart,height,rightside-GadgetWidth(bWorkdir),workdir)
  height+gvMultiCenter(lWorkdir,tWorkdir,bWorkdir)
  
  cCreateLib=gCheckbox(5,height,width-10,"Create default IncludeLibraries"):height+GadgetHeight(cCreateLib)
  
  bTools=gRightAlign(gButton(rightStart,height,0,"..."),rightside)  
  cTools=gCheckbox(leftStart,height,leftside,"Add PreCompiler to Tools")
  tTools=gString(rightStart,height,rightside-GadgetWidth(bTools),ToolPrefs)
  height+gvMultiCenter(cTools,tTools,bTools)
  
  bIde=gRightAlign(gButton(rightStart,height,0,"..."),rightside)  
  cIde=gCheckbox(leftStart,height,leftside,"Add pbLib to IDE")
  tIde=gString(rightStart,height,rightside-GadgetWidth(bIde),PureBasicPrefs)
  height+gvMultiCenter(cIde,tIde,bIde)
  
  height+5
  bdeinstall=gButton(5,height,0,"Deinstall")
  bCancel=gRightAlign(gButton(5,height,0,"Cancel"),width-10)
  bInstall=gRightAlign(gButton(5,height,0,"Install",#PB_Button_Default),width-10-5-GadgetWidth(bCancel))
  height+gvMultiCenter(bdeinstall,bCancel,bInstall)
  
  height+5
  ResizeWindow(win,#PB_Ignore,#PB_Ignore,width,height)
  HideWindow(win,#False,#PB_Window_ScreenCentered)
  
  SetGadgetState(cIde,#True)
  SetGadgetState(cTools,#True)
  SetGadgetState(cCreateLib,#True)
  
  Enumeration 1
    #menu_install
    #menu_cancel
    #menu_deinstall
  EndEnumeration
  
  AddKeyboardShortcut(win,#PB_Shortcut_Escape,#menu_cancel)
  AddKeyboardShortcut(win,#PB_Shortcut_Return,#menu_install)
  
  
  Protected event
  Protected do=#menu_cancel
  Protected string.s
  Repeat
    event=WaitWindowEvent()
    
    Select event
      Case #PB_Event_Menu
        do=EventMenu()
        Break
      Case #PB_Event_Gadget
        Select EventGadget()
          Case bWorkdir
            string=PathRequester(#title+" - Please select the PreCompiler working directory",
                                 GetGadgetText(tWorkdir))
            If string
              SetGadgetText(tWorkdir,string)
            EndIf
          Case bTools
            string=OpenFileRequester(#title + " - Please select the PureBasic "+#pbToolsPref,
                                     GetGadgetText(tTools),
                                     "Prefs|*.Prefs;*.prefs|All files|*.*",0)
            If string
              SetGadgetText(tTools,string)
            EndIf
          Case bIde
            string=OpenFileRequester(#title + " - Please select the PureBasic "+#pbPurebasicPrefs,
                                     GetGadgetText(tIde),
                                     "Prefs|*.Prefs;*.prefs|All files|*.*",0)
            If string
              SetGadgetText(tIde,string)
            EndIf
          Case bPBCompiler
            string=OpenFileRequester(#title + " - Please select the PureBasic "+GetFilePart(#pb_compiler),
                                     GetGadgetText(tPBCompiler),
                                     GetFilePart(#pb_compiler)+"|"+GetFilePart(#pb_compiler)+"|All files|*.*",0)
            If string
              SetGadgetText(tPBCompiler,string)
            EndIf
          Case bInstall
            do=#menu_install
            Break
          Case bCancel
            do=#menu_cancel
            Break
          Case bdeinstall
            do=#menu_deinstall
            Break
        EndSelect
    EndSelect
  Until event=#PB_Event_CloseWindow
  
  ;- close window
  
  Protected PBCompiler.s,pbhome.s
  Protected dolib,dotool,doide
  PBCompiler=GetGadgetText(tPBCompiler)
  pbhome=GetPathPart(PBCompiler):pbhome=GetPathPart(Left(pbhome,Len(pbhome)-1))
  workdir=GetGadgetText(tWorkdir)
  ToolPrefs=GetGadgetText(tTools)
  PureBasicPrefs=GetGadgetText(tIde)
  dolib=GetGadgetState(cCreateLib)
  dotool=GetGadgetState(cTools)
  doide=GetGadgetState(cide)
  
  CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
    ;I don't know why, but the setup-window will not close....
    ResizeWindow(win,0,0,0,0)
    HideWindow(win,#False)
    Protected timer=ElapsedMilliseconds()+100
    While ElapsedMilliseconds()<timer
      WindowEvent()
      Delay(0)
    Wend    
  CompilerEndIf
  CloseWindow(win)
  
    
  If do=#menu_deinstall ;-deinstall
    Protected doRepeat,dir,name.s,ext.s
    
    If doide And PureBasicPrefs<>"" And OpenPreferences(PureBasicPrefs)
      PreferenceGroup("Editor")
      ext=ReadPreferenceString("CodeFileExtensions","")
      ext=ReplaceString(ext,"pbLib","")
      ext=ReplaceString(ext,",,",",")
      If Left(ext,1)=","
        ext=Mid(ext,2)
      EndIf
      WritePreferenceString("CodeFileExtensions",ext)
      ClosePreferences()
    EndIf
    
    If dotool
      RemoveToolPrefs(ToolPrefs,execute)
    EndIf
    
    If dolib
      Repeat
        doRepeat=#False
        dir=ExamineDirectory(#PB_Any,workdir,"*.*")
        If dir
          While NextDirectoryEntry(dir)
            name=DirectoryEntryName(dir)
            If DirectoryEntryType(dir)=#PB_DirectoryEntry_File And name<>"." And name<>".."
              If Right(name,4)=".log"
                name=Left(name,Len(name)-4)
                doRepeat=#True
              ElseIf Right(name,5)=".info"
                name=Left(name,Len(name)-5)
                doRepeat=#True
              ElseIf Right(name,7)=".res.pb"
                name=Left(name,Len(name)-7)
                doRepeat=#True
              ElseIf Right(name,12)=".declare.pbi"
                name=Left(name,Len(name)-12)
                doRepeat=#True
              ElseIf Right(name,3)=".pb"
                name=Left(name,Len(name)-3)
                doRepeat=#True
              EndIf
              If doRepeat
                ;Debug "Remove "+name
                DeleteFile(workdir+name+".declare.pbi")
                DeleteFile(workdir+name+".define.pbi")
                DeleteFile(workdir+name+".info")
                DeleteFile(workdir+name+".res.pb")
                DeleteFile(workdir+name+".pb")
                DeleteFile(workdir+name+".log")
                ;Debug PBHome+#path_residents+name+".res"
                ;Debug pbhome+#path_userlibraries+name
                DeleteFile(PBHome+#path_residents+name+".res")
                DeleteFile(pbhome+#path_userlibraries+name)
                Break
              EndIf
            EndIf
          Wend
        EndIf
      Until doRepeat=#False
    EndIf
    
    MessageRequester(#title,"Deinstallation complete.")
    End
      
  EndIf
  
  If do<>#menu_install
    End
  EndIf
  
  ;-install
  
  CompilerIf #PB_Compiler_OS=#PB_OS_MacOS
    OpenPreferences(inifile)
    WritePreferenceString("WorkingDir",workdir)
    ClosePreferences()    
  CompilerEndIf
  
  
  If dolib
    Protected path.s=GetPathPart(mainfile);,dir
    SetEnvironmentVariable("PB_TOOL_Compiler",PBCompiler)
    SetEnvironmentVariable("PUREBASIC_HOME",pbhome)
    SetEnvironmentVariable("PATH",GetEnvironmentVariable("PATH")+","+pbhome)
    
    RunProgram(execute,#DQUOTE$+path+"libClass.pbLib"+#DQUOTE$+" "+#DQUOTE$+#DQUOTE$+" "+#DQUOTE$+#DQUOTE$+" CreateLib Quite",workdir,#PB_Program_Wait)
    RunProgram(execute,#DQUOTE$+path+"constants.pbLib"+#DQUOTE$+" "+#DQUOTE$+#DQUOTE$+" "+#DQUOTE$+#DQUOTE$+" CreateLib Quite",workdir,#PB_Program_Wait)
    RunProgram(execute,#DQUOTE$+path+"libDirectory.pbLib"+#DQUOTE$+" "+#DQUOTE$+#DQUOTE$+" "+#DQUOTE$+#DQUOTE$+" CreateLib Quite",workdir,#PB_Program_Wait)
    RunProgram(execute,#DQUOTE$+path+"libFile.pbLib"+#DQUOTE$+" "+#DQUOTE$+#DQUOTE$+" "+#DQUOTE$+#DQUOTE$+" CreateLib Quite",workdir,#PB_Program_Wait)
    RunProgram(execute,#DQUOTE$+path+"libIndexMap.pbLib"+#DQUOTE$+" "+#DQUOTE$+#DQUOTE$+" "+#DQUOTE$+#DQUOTE$+" CreateLib Quite",workdir,#PB_Program_Wait)
  EndIf
  
  InfoText("Configure "+#pbToolsPref)
  
  Protected count,i,ok
  If dotool And ToolPrefs<>"" And  OpenPreferences(ToolPrefs)
    PreferenceGroup("ToolsInfo")
    count=ReadPreferenceLong("ToolCount",0)
    
    ok=#True
    For i=0 To count-1
      PreferenceGroup("Tool_"+i)
      If ReadPreferenceString("Command","")=execute
        ok=#False
        Break
      EndIf
    Next
    
    If ok
      PreferenceGroup("Tool_"+count):count+1
      WritePreferenceString("Command",execute)
      WritePreferenceString("Arguments",~"\"%FILE\" \"%COMPILEFILE\" \"%EXECUTABLE\"")
      WritePreferenceString("WorkingDir",workdir)
      WritePreferenceString("MenuItemName","PreCompiler")
      WritePreferenceLong("Trigger",3)
      WritePreferenceLong("Flags",1)
      
      PreferenceGroup("Tool_"+count):count+1
      WritePreferenceString("Command",execute)
      WritePreferenceString("Arguments",~"\"%FILE\" \"%COMPILEFILE\" \"%EXECUTABLE\"")
      WritePreferenceString("WorkingDir",workdir)
      WritePreferenceString("MenuItemName","PreCompiler Executeable")
      WritePreferenceLong("Trigger",6)
      WritePreferenceLong("Flags",1)
      WritePreferenceLong("HideFromMenu",1)
      
      PreferenceGroup("Tool_"+count):count+1
      WritePreferenceString("Command",execute)
      WritePreferenceString("Arguments",~"\"%FILE\" \"%COMPILEFILE\" \"%EXECUTABLE\" CreateLib")
      WritePreferenceString("WorkingDir",workdir)
      WritePreferenceString("MenuItemName","PreCompiler Create Lib")
      WritePreferenceLong("Trigger",0)
      
      PreferenceGroup("Tool_"+count):count+1
      WritePreferenceString("Command",execute)
      WritePreferenceString("Arguments",~"\"%FILE\" \"%COMPILEFILE\" \"%EXECUTABLE\" DeleteLib")
      WritePreferenceString("WorkingDir",workdir)
      WritePreferenceString("MenuItemName","PreCompiler Delete Lib")
      WritePreferenceLong("Trigger",0)
      
      PreferenceGroup("ToolsInfo")
      WritePreferenceLong("ToolCount",count)
    EndIf
    ClosePreferences()
    
    
  EndIf
  
  InfoText("Configure "+#pbPurebasicPrefs)
  If doide And PureBasicPrefs<>"" And OpenPreferences(PureBasicPrefs)
    PreferenceGroup("Editor")
    ext=ReadPreferenceString("CodeFileExtensions","")
    If FindString(ext,"pbLib",1,#PB_String_NoCase)=0
      If ext<>"":ext+",":EndIf
      ext+"pbLib"
      WritePreferenceString("CodeFileExtensions",ext)
    EndIf
    ClosePreferences()
  EndIf
  
  MessageRequester(#title,"DONE!")
EndProcedure
; IDE Options = PureBasic 5.61 (MacOS X - x64)
; CursorPosition = 366
; FirstLine = 330
; Folding = ----
; EnableXP