﻿;-
Procedure AddNeededLibraries(newlib.s)
  Protected ok=#True
  ForEach NeededLibraries()
    If NeededLibraries()=newlib
      ok=#False 
      Break
    EndIf
  Next      
  
  If ok And FileSize(newlib+".declare.pbi")>0
    LastElement(NeededLibraries())
    AddElement(NeededLibraries())
    NeededLibraries()=newlib
  Else
    ok=#False
  EndIf
  ProcedureReturn ok
EndProcedure
Procedure CreateNeededLibraries(NeededLibrariesFile.s)
  Protected out
  out=CreateFile(#PB_Any,NeededLibrariesFile)
  If out
    ForEach NeededLibraries()
      WriteStringN(out,"XIncludeFile "+#DQUOTE$+NeededLibraries()+".declare.pbi"+#DQUOTE$)
    Next
    ForEach NeededLibraries()
      WriteStringN(out,"XIncludeFile "+#DQUOTE$+NeededLibraries()+".define.pbi"+#DQUOTE$)
    Next
    WriteStringN(out,";-**** MainFile ****")
    CloseFile(out)
  EndIf
  ProcedureReturn out
EndProcedure
Procedure PrimaryProcess()
  
  ;{ Read SourceFile
  InfoText("Read "+CompilerInputFile)
  
  Protected in
  If IsIDECompile()
    in=MyReadFile(#PB_Any,CompilerInputFile)
  Else
    in=MyReadFile(#PB_Any,OriginalMainFile)
  EndIf
  
  If in=0
    CreateErrorFile("Can't read File!" + CompilerInputFile,CompilerInputFile,NeededLibrariesFile,#True)
    CloseInfoWindow()
    If Not IsIDECompile()
      MessageRequester(#title,"Can't read file!"+#LineEnd+OriginalMainFile)
    EndIf
    End
  EndIf
  
  ReadStringFormat(in)
  While Not Eof(in)
    AddElement(CompleteFile())
    CompleteFile()=ReadString(in)
  Wend
  CloseFile(in)
  ;}
  
  ;{ Create NewSourceFile
  Protected out
  
  out=MyCreateFile(#PB_Any,CompilerInputFile)
  If out
    WriteString(out,"XIncludeFile "+#DQUOTE$+NeededLibrariesFile+#DQUOTE$+":"+
                    "IncludePath "+#DQUOTE$+GetPathPart(OriginalMainFile)+#DQUOTE$+":")
    ForEach CompleteFile()
      WriteStringN(out, CompleteFile() )
    Next
    CloseFile(out)
  EndIf
  ;}
  
  ;{ Create PreProcess tempfile
  InfoText("Create Preprocess")
  Protected pos,newlib.s
  
  ;It seems, that for peprocess all this parameter are ignored...

  Repeat
    CreateNeededLibraries(NeededLibrariesFile)
    If Program(PBCompiler, 
               #DQUOTE$+CompilerInputFile+#DQUOTE$+" "+
               #flag_PreProcess+" "+#DQUOTE$+TempFile+#DQUOTE$+
               CompilerFlags+" "+#flag_Constant+" __PreCompilerPreProcess__=1", 
               GetPathPart(OriginalMainFile))
      
      ;-....Missing module? -> addLibrary
      pos=FindString(programOutput,#Compiler_ErrorModule,0,#PB_String_NoCase)
      If pos 
        pos+Len(#Compiler_ErrorModule)
        newlib=Trim(Mid(programOutput,pos,FindString(programOutput,#Compiler_ErrorModuleEnd,pos,#PB_String_NoCase)-pos))
        If AddNeededLibraries(PreCompilerHome+newlib)=#False 
          If AddNeededLibraries(PreCompilerHome+CompilerOsBin+"_"+LCase(newlib)+".module")
            ExportModuleMap(LCase(newlib))\doIgnore=#True  
          Else          
            pos=0
          EndIf
        EndIf
      EndIf
      
      If pos=0    
        CreateErrorfile("PreProcess:"+programOutput,CompilerInputFile,NeededLibrariesFile)
        CloseInfoWindow()
        If Not IsIDECompile()
          MessageRequester(#title,"PreProcess:"+#LineEnd+programOutput)
        EndIf
        End
      EndIf    
      
    Else
      Break
    EndIf
  ForEver
  ;}
  
  ;{ parse tempfile
  InfoText("Process OriginalMainFile")
  Protected line.s,word.s,pos2,pos3,pos4;,pos
  Protected inClassInterface=0,inClassStructure=0,inMacro=0,firstClassLibAdd=0
  Protected inStructure=0,inInterface=0
  Protected ClassName.s,typ.s,name.s,para.s,extends.s
  Protected ModuleName.s,proc.s,class.s,ProcComplete.s
  Protected DoExport=0,orgline.s,string.s
  in = MyReadFile(#PB_Any,TempFile)
  If in=0
    MessageRequester(#title,"Can't open temp file"+#LineEnd+tempfile)
    End
  EndIf
  
  While Not Eof(in)
    InfoLoop()
    orgline=Trim(ReadString(in))
    line=orgline
    While Right(line,1)=":" : line=Trim(Left(line,Len(line)-1)) : Wend
    While FindString(line,"  "):line=ReplaceString(line,"  "," "):Wend
    
    word=StringField(StringField(line,1," "),1,".")
    
    ; remove Runtime - PreWord
    If word="Runtime"
      line=Mid(line,9)
      word.s=StringField(StringField(line,1," "),1,".")
    EndIf
    
    word=Trim(word)
    
    ; Export 
    If DoExport And (Left(word,23)<>"#__PreCompilerCommand__" Or FindString(line,"__c34__",0,#PB_String_NoCase)>0)
      AddElement(AddResourceFile())
      AddResourceFile()=orgline
    EndIf
    
    Select LCase(word)
      Case "macro";- ....Macro
        inMacro=#True
        
      Case "endmacro";- ....EndMacro
        inMacro=#False
        
      Case "declaredll","declarecdll";- ....declaredll declarecdll
        If inMacro=#False
        EndIf
        
      Case "proceduredll","procedurecdll";- ....ProcedureDLL
        If inMacro=#False
          CheckCreateLibError(word)
          
          AddElement(ExportDLL())
          pos=Len(word)+1
          While Mid(line,pos,1)<>" ":pos+1:Wend
          ExportDLL()\typ=Trim(Mid(line,Len(word)+1,pos-Len(word)-1))
          
          While Mid(line,pos,1)=" ":pos+1:Wend
          pos2=FindString(line,"(")
          
          ExportDLL()\name=Trim(Mid(line,pos,pos2-pos))
          ExportDLL()\para=Trim(Mid(line,pos2))
          If LCase(Right(word,4))="cdll"
            ExportDLL()\isCDECL=#True
          EndIf
        EndIf
        
      Case "procedure","procedurec";- ....procedure
        If inMacro=#False
          CheckCreateLibError(word)
          If FindString(line,"*self",0,#PB_String_NoCase)
            pos=Len(word)+1
            While Mid(line,pos,1)<>" ":pos+1:Wend
            While Mid(line,pos,1)=" ":pos+1:Wend
            pos2=pos
            While Mid(line,pos2,1)<>" " And Mid(line,pos2,1)<>"(":pos2+1:Wend
            ProcComplete=Mid(line,pos,pos2-pos)
            ;Debug "***"+ProcComplete
            
            If FindMapElement(Class_Proc(),UCase(ModuleName+"::"+ProcComplete))
              proc=Class_Proc()\proc
              class=Class_Proc()\class
              
              If FindMapElement(class(),UCase(ModuleName+"::"+class))
                If FindListElement(class()\method(),proc)
                  If ModuleName<>""
                    class()\method()\vt=ModuleName+"::@"+ProcComplete+"()"
                  Else
                    class()\method()\vt="@"+ProcComplete+"()"
                  EndIf
                  class()\method()\NotInherited=#True
                EndIf          
              EndIf
            EndIf
          EndIf
        EndIf
        
      Case "module","declaremodule" ;- ....Module/DeclareModule
        If inMacro=#False
          pos=Len(word)+2
          While Mid(line,pos,1)=" ":pos+1:Wend
          pos2=FindString(line," ",pos):If pos2=0:pos2=Len(line)+1:EndIf
          ModuleName=Mid(line,pos,pos2-pos)
          
          If FindMapElement( ExportModuleMap(), LCase(ModuleName) )=0
            CheckCreateLibError(word)
          EndIf
        EndIf
        
      Case "endmodule","enddeclaremodule";- ....EndModule, EndDeclareModule
        If inMacro=#False
          ModuleName=""
        EndIf
        
      Case "prototype","prototypec";- ....Prototype
        If inMacro=#False
          CheckCreateLibError(word)
        EndIf
        
      Case "structure";- ....Structure
        If inMacro=#False
          inStructure=#True
          pos=11
          While Mid(line,pos,1)=" ":pos+1:Wend
          pos2=FindString(line," ",pos):If pos2=0:pos2=Len(line)+1:EndIf
          ClassName=Mid(line,pos,pos2-pos)
          If Asc(ClassName)='s' Or Asc(ClassName)='S'
            extends=""
            pos3=FindString(line," Extends ",pos2,#PB_String_NoCase)
            If pos3
              pos3+9
              While Mid(line,pos3,1)=" ":pos3+1:Wend
              pos4=FindString(line," ",pos3):If pos4=0:pos4=Len(line)+1:EndIf
              extends=Mid(line,pos3,pos4-pos3)
              If FindString(extends,"::")=0 
                If FindMapElement(class(),"::"+UCase(Mid(Extends,2)))
                  extends="::"+extends
                Else
                  extends=ModuleName+"::"+extends
                EndIf              
              EndIf
              extends=ReplaceString(Extends,"::s","::",#PB_String_NoCase)   
              
            EndIf
            If FindMapElement(class(), UCase(ModuleName+"::"+Mid(classname,2)) )
              inClassStructure=#True
              extends=UCase(Extends)
              If extends<>""
                CopyList(class(extends)\struc(),
                         class(UCase(ModuleName+"::"+Mid(classname,2)))\struc() )
                LastElement(  class(UCase(ModuleName+"::"+Mid(classname,2)))\struc() )
              EndIf
              
              If extends <> UCase( class()\extends)
                If class()\extends<>""
                  class()\ErrorText+"Structure "+ClassName+" should extends "+ReplaceString(class()\extends,"::","::s")+"! "
                Else
                  class()\ErrorText+"Structure "+ClassName+" should not extend! "
                EndIf
                ;ErrorText+ModuleName+"::"+ClassName+" extends "+extends+" should s"+class()\extends+"! "
              EndIf
            EndIf
          EndIf
        EndIf
        
      Case "interface";- ....Interface
        If inMacro=#False
          inInterface=#True
          pos=11
          While Mid(line,pos,1)=" ":pos+1:Wend
          pos2=FindString(line," ",pos):If pos2=0:pos2=Len(line)+1:EndIf
          ClassName=Mid(line,pos,pos2-pos)
          
          If UCase(ClassName)<>"THIS"
            extends.s=""
            pos3=FindString(line," Extends ",pos2,#PB_String_NoCase)
            If pos3
              pos3+9
              While Mid(line,pos3,1)=" ":pos3+1:Wend
              pos4=FindString(line," ",pos3):If pos4=0:pos4=Len(line)+1:EndIf
              extends=Mid(line,pos3,pos4-pos3)
              If FindString(extends,"::")=0 
                If FindMapElement(class(),"::"+UCase(Extends))
                  extends="::"+extends
                Else
                  extends=ModuleName+"::"+extends
                EndIf
              EndIf
              
              class(UCase(ModuleName+"::"+classname))\extends=extends 
            EndIf
            extends=UCase(extends)
            
            class(UCase(ModuleName+"::"+classname))\name=ModuleName+"::"+ClassName
            inClassInterface=#True
            
            If extends<>""
              CopyMethodList( class(UCase(extends))\method(),
                              class(UCase(ModuleName+"::"+classname))\method(),
                              ClassName,
                              ModuleName)
            EndIf
            
            class(UCase(ModuleName+"::"+classname))
            
            AddMethod(ModuleName,ClassName,ClassName          ,")","",#True)
            AddMethod(ModuleName,ClassName,"De"+ClassName     ,")","",#True)
            AddMethod(ModuleName,ClassName,ClassName+"Ex"     ,",*para)","",#True)
            AddMethod(ModuleName,ClassName,"_Constructor"    ,")","",#True)
            AddMethod(ModuleName,ClassName,"_ConstructorEx"  ,",*para)","",#True)
            AddMethod(ModuleName,ClassName,"_Destructor"     ,")","",#True)
            AddMethod(ModuleName,ClassName,"_CopyConstructor",")","",#True)
            AddElement(classlist())
            classlist()=ModuleName+"::"+classname
          EndIf
        EndIf
        
      Case "endinterface";- ....EndInterface
        If inMacro=#False
          inInterface=#False
          inClassInterface=#False
        EndIf
        
      Case "endstructure";- ....EndStructure
        If inMacro=#False
          inStructure=#False
          inClassStructure=#False
        EndIf
        
      Default 
        If inMacro=#False And Left(word,1)<>";"
          
          If Left(word,23)="#__PreCompilerCommand__" ;- ....PreCompilerCommand
            pos=FindString(line,#DQUOTE$)
            line=Mid(line,pos+1,Len(line)-1-pos)
            word=StringField(line,1," ")
            
            Select word
              Case "ExportModule";- ........ExportModule
                word=LCase(Mid(line,14))
                ExportModuleMap(word)
                
              Case "AddResFile";- ........AddResFile
                word=Mid(line,12)
                Debug "**"+word+"**"
                AddElement(NeededResources())
                NeededResources()=word
                
              Case "ExportStart";- ........ExportStart
                DoExport=#True
                
              Case "ExportEnd"  ;- ........ExportEnd
                DoExport=#False
                
              Case "ExportClass";- ........ExportClass class
                AddElement(ExportClassList())
                ExportClassList()=LCase(StringField(line,2," "))
                
              Case "DeclareClass","DefineClass" ;- ........DeclareClass Classname extends extendclass AllowNull
                If firstClassLibAdd=0
                  firstClassLibAdd=#True
                  If DoCommand<>#DoCreateLib Or libname<>CompilerOsBin+"_libClass"
                    If AddNeededLibraries(PreCompilerHome+CompilerOsBin+"_libClass")
                      CreateNeededLibraries(NeededLibrariesFile)
                    EndIf
                  EndIf
                EndIf
                
                ClassName=StringField(line,2," ")
                
                extends=StringField(line,4," ")
                If extends="/":Extends="":EndIf
                If extends<>"" And FindString(extends,"::")=0 
                  If FindMapElement(class(),"::"+UCase(Extends))
                    extends="::"+extends
                  Else
                    extends=ModuleName+"::"+extends
                  EndIf
                EndIf   
                
                If class(UCase(ModuleName+"::"+ClassName))\defined=0
                  class()\defined=#True
                  
                  string=UCase(StringField(line,5," "))
                  If string="#TRUE" Or Val(string)=1
                    class()\AllowNull=1
                  EndIf
                  
                  If extends<>"" 
                    If class(UCase(extends))\forcedLib
                      If AddNeededLibraries(class()\forcedLib)
                        CreateNeededLibraries(NeededLibrariesFile)
                      EndIf                 
                    EndIf
                    class(UCase(ModuleName+"::"+ClassName))
                  EndIf
                Else
                  
                  string=UCase(StringField(line,5," "))
                  If string="#TRUE" Or Val(string)=1
                    If class()\AllowNull=0
                      class()\ErrorText + "Class "+ClassName+" definition doesn't match declartion."
                    EndIf
                  Else
                    If class()\AllowNull=1
                      class()\ErrorText + "Class "+ClassName+" definition doesn't match declartion."
                    EndIf
                  EndIf
                  
                EndIf
                
                
                If UCase(extends)<>UCase(class()\extends)
                  ;ErrorText+ModuleName+"::"+ClassName+" extends "+extends+" should "+class()\extends+"! "
                  If class()\extends<>""
                    class()\ErrorText + word +" "+ClassName+" should extends "+RemoveDoubleColon(class()\extends)+"! "
                  Else
                    class()\ErrorText + word +" "+ClassName+" should not extend! "
                  EndIf
                EndIf
              Default
                Debug "************* UNKNOWN COMMAND:"+word
            EndSelect
            
          ElseIf inClassStructure And line<>"" And Left(line,1)<>";" ;- ....inClassStructure
            AddElement(class(UCase(ModuleName+"::"+Mid(classname,2)))\struc())
            class()\struc()=orgline
            
          ElseIf inClassInterface And line<>"" And Left(line,1)<>";" ;- ....inClassInterface
            pos=FindString(line,"(")
            name.s=Trim(Left(line,pos-1))
            typ.s=StringField(name,2,".")
            name=StringField(name,1,".")
            If typ<>""
              typ="."+typ
            EndIf
            para.s=Trim(Mid(line,pos+1))
            If para<>")"
              para=","+para
            EndIf   
            name=Trim(name)
            
            string=UCase(name)
            If string=UCase(ClassName) Or
               string=UCase("De"+ClassName) Or
               string=UCase(ClassName+"Ex") Or
               string="_CONSTRUCTOR" Or
               string="_CONSTRUCTOREX" Or
               string="_DESTRUCTOR" Or
               string="_COPYCONSTRUCTOR"
              class()\ErrorText="Reserved method name "+name+"! "
            Else
              AddMethod(ModuleName,ClassName,name,para,typ)
            EndIf
          Else
            ;- ....Createlibcheck
            If inMacro=#False And inStructure=#False And inInterface=#False And line<>"" And Left(word,1)<>"#"
              CheckCreateLibError("variables,etc.")
            EndIf
          EndIf
        EndIf
    EndSelect
    
  Wend
  
  CloseFile(in)
  ;}
  
  ;{ Write CompilerInputFile
  InfoText("Write Output "+CompilerInputFile)
 
  out=MyCreateFile(#PB_Any,CompilerInputFile)
  If out=0  
    CloseInfoWindow()
    CreateErrorfile("Can't create CompilerInputFile!",CompilerInputFile,NeededLibrariesFile,#True)
    If Not IsIDECompile()
      MessageRequester(#title,"Can't create file!"+#LineEnd+CompilerInputFile)
    EndIf
    End
  EndIf
  
  ;     writestring(out,out)
  WriteString(out,"DeclareModule _PreCompiler_:"+
                  "#ClassInfoPath="+#DQUOTE$+classinfopath+#DQUOTE$+":"+
                  "EndDeclareModule:"+
                  "Module _PreCompiler_:"+
                  "EndModule:"+
                  "XIncludeFile "+#DQUOTE$+NeededLibrariesFile+#DQUOTE$+":")
  
  If Not IsIDECompile()
    WriteString(out,"IncludePath "+#DQUOTE$+GetPathPart(OriginalMainFile)+#DQUOTE$+":")
  EndIf
  ForEach CompleteFile()
    WriteStringN(out,CompleteFile())
  Next

  CloseFile(out)
  ;}
  
  ;{ Create includefile for class
  Protected vt.s, namelist.s, *vtlink.method, vtstring.s,vt_i
  Protected paralist.s
  Protected inherited
  Protected i,ii
  Protected uplist.s
  Protected isExported
  
  NewList declarelist.s()
  
  ForEach classlist()
    class(UCase(classlist()))
    If class()\defined
      classname=StringField(classlist(),2,"::")
      ModuleName=StringField(classlist(),1,"::")
      
      If FindExportClass(ClassName)
        isExported=#True
      Else
        isExported=#False
      EndIf
      
      ;- ........declare
      InfoText("Create "+ModuleName+"_"+ClassName)
      out=MyCreateFile(#PB_Any,classinfopath+ModuleName+"_"+ClassName+".declare.pbi")
      WriteStringN(out,";DeclareClass "+ModuleName+"_"+classname)
      vt.s=""
      namelist.s=""
      paralist.s=""
      vt_i=0
      
      ClearList(declarelist())
      
      If FirstElement(class()\method()) And class()\method()\VTlink<>0
        AddElement(declarelist()):Declarelist()=";************** inherited **************"
        inherited=0
      Else
        inherited=1
      EndIf
      ForEach class()\method()
        
        *vtlink=class()\method()
        
        ;search VT from parent if neccassery
        While *vtlink\vt="" And *vtlink\VTlink
          *vtlink=*vtlink\VTlink
        Wend
        
        If class()\method()\vt<>""
          vtstring=class()\method()\vt
        ElseIf class()\extends<>"" And *vtlink\vt<>""
          vtstring="*parent\vt\pMethod["+vt_i+"]"
        Else
          vtstring="#Null"
        EndIf
        
        
        With class()\method()
          If inherited=0 And \VTlink=0 
            inherited=1
            AddElement(declarelist()):Declarelist()=";************** this **************"
          EndIf
          
          ;         If isExported
          ;           If \vt<>""
          ;             AddElement(ExportLibDeclare())
          ;             ExportLibDeclare()= "Declare"+ \typ +" "+ ClassName +"_"+ \name + "(*self" +\para
          ;           EndIf
          ;         EndIf  
          If \isSpecial=#False Or \NotInherited
            AddElement(declarelist())
            If \NotInherited=#False And (class()\AllowNull=#True Or *vtlink\vt<>"")
              Declarelist()=";"
            EndIf
            Declarelist()+"Declare"+\typ+" "+ClassName+"_"+\name+"(*self.s"+ClassName + \para 
            If \NotInherited=#False
              declarelist()+"  ; "+vtstring
            EndIf
            
            If class()\AllowNull=#False And *vtlink\vt=""
              class()\ErrorText+" Missing Method "+ \name+"! " 
            EndIf
            
          EndIf
          
          
          If \isSpecial=#False
            vt+ #LineEnd+"    \vt\pMethod["+vt_i+"]="+vtstring
            
            If (vt_i %5)=0
              
              If namelist=""
                namelist="#"+ClassName+"_Nametable="+#DQUOTE$+ \name
              Else
                namelist+";"+ #DQUOTE$+"+" + #LineEnd + Space(Len(ClassName)+12) + #DQUOTE$ +\name
              EndIf
              
              If paralist=""
                paralist="#"+ClassName+"_Paratable="+#DQUOTE$+ SimplePara( \para)
              Else
                paralist+";"+ #DQUOTE$+"+" + #LineEnd + Space(Len(ClassName)+12) + #DQUOTE$ + SimplePara( \para)
              EndIf
              
            Else
              
              namelist+ ";"+\name
              paralist+ ";" + SimplePara( \para )
              
            EndIf
            
            vt_i+1
            
          EndIf
          
          
          
        EndWith
        
        
      Next
      namelist+#DQUOTE$
      paralist+#DQUOTE$
      ;WriteStringN(out, "Declare   "+ClassName+"___Allocate()" )
      ;WriteStringN(out, "Declare   "+ClassName+"___Copy(*obj)")
      WriteStringN(out, "Global "+classname+".__class")
      WriteStringN(out, "Declare.i __"+ClassName+"_Init()")
      
      If isExported
        AddElement(exportDLL())
        ExportDLL()\isCDECL=#False
        ExportDLL()\maxopt=0
        ExportDLL()\name="__"+ClassName+"_Init"
        ExportDLL()\para="()"
        ExportDLL()\typ=".i"
        AddElement(ExportLibDeclare()):ExportLibDeclare()= "__"+ClassName+"_Init()"
      Else        
        WriteStringN(out, "__"+ClassName+"_Init()")
      EndIf
      WriteStringN(out, "" )
      
      
      class()\paralist=paralist
      class()\namelist=namelist
      WriteStringN(out, namelist )
      WriteStringN(out, paralist )
      WriteStringN(out, "" )
      
      ;- ............ Errortext
      WriteStringN(out, "#__"+classname+"_error__="+#DQUOTE$+ class()\ErrorText + #DQUOTE$)
      
      WriteStringN(out,";EndDeclareClass")
      CloseFile(out)
      
      ;- ........define
      out=MyCreateFile(#PB_Any,classinfopath+ModuleName+"_"+ClassName+".define.pbi")
      WriteStringN(out,";DefineClass "+ModuleName+"_"+classname)
      
      i=1
      While class()\extends
        class(UCase(class()\extends))
        i+1
      Wend
      class(UCase(classlist()))
      
      
      ForEach declarelist()
        WriteStringN(out,declarelist())
      Next
      WriteStringN(out,"Procedure.i "+ClassName+"___Allocate()" )
      WriteStringN(out,"  ProcedureReturn AllocateStructure(s"+ClassName+")" )
      WriteStringN(out,"EndProcedure" )
      WriteStringN(out,"Procedure.i "+ClassName+"___Copy(*obj)" )
      WriteStringN(out,"  Protected *new=AllocateStructure(s"+ClassName+")" )
      WriteStringN(out,"  If *new" )
      WriteStringN(out,"    CopyStructure(*obj,*new,s"+ClassName+")" )
      WriteStringN(out,"  EndIf" )
      WriteStringN(out,"  ProcedureReturn *new" )
      WriteStringN(out,"EndProcedure" )
      WriteStringN(out,"Procedure.i "+ClassName+"___Free(*obj)" )
      WriteStringN(out,"  ProcedureReturn FreeStructure(*obj)" )
      WriteStringN(out,"EndProcedure" )
      
      WriteStringN(out,"Structure __"+ClassName+"_vt_")
      WriteStringN(out,"  *classinfo")
      WriteStringN(out,"  *pmethods["+vt_i+"]")
      WriteStringN(out,"EndStructure")
      WriteStringN(out,"Structure __"+ClassName+"_Uplist_")
      WriteStringN(out,"  *pUplist["+Str(i+1)+"]")
      WriteStringN(out,"EndStructure")
      CompilerIf #LibType=#LibStatic 
        If FindExportClass(ClassName)
          WriteStringN(out,"ProcedureDLL __"+ClassName+"_Init()")
        Else
          WriteStringN(out,"Procedure __"+ClassName+"_Init()")
        EndIf
      CompilerElse
        WriteStringN(out,"Procedure __"+ClassName+"_Init()")
      CompilerEndIf
      WriteStringN(out,"  Static classinfo.__classinfo" )
      WriteStringN(out,"  Static vt.__"+ClassName+"_vt_" )
      WriteStringN(out,"  Static Uplist.__"+ClassName+"_Uplist_" )
      WriteStringN(out,"  Protected *parent.__classinfo")
      WriteStringN(out,"  If vt\classinfo=#Null")
      WriteStringN(out,"    vt\classinfo = classinfo")
      WriteStringN(out,"    "+ClassName+"= @classinfo" )
      WriteStringN(out,"    With classinfo" )
      WriteStringN(out,"      \Class_VT=__Get_vt_New()" )
      WriteStringN(out,"      \SizeOfVT = SizeOf("+ClassName+")" )      
      If (FindListElement(class()\method(),ClassName) And class()\method()\vt<>"") Or 
         (FindListElement(class()\method(),"_Constructor") And class()\method()\vt<>"")
        WriteStringN(out,"      \Constructor="+class()\method()\vt+"" )
      EndIf
      If (FindListElement(class()\method(),ClassName+"Ex") And class()\method()\vt<>"") Or 
         (FindListElement(class()\method(),"_ConstructorEx") And class()\method()\vt<>"")
        WriteStringN(out,"      \ConstructorEx="+class()\method()\vt+"" )
      EndIf
      If (FindListElement(class()\method(),"_CopyConstructor") And class()\method()\vt<>"")
        WriteStringN(out,"      \CopyConstructor="+class()\method()\vt+"" )
      EndIf
      If (FindListElement(class()\method(),"De"+ClassName) And class()\method()\vt<>"") Or 
         (FindListElement(class()\method(),"_Destructor") And class()\method()\vt<>"")
        WriteStringN(out,"      \Destructor="+class()\method()\vt+"" )
      EndIf
      WriteStringN(out,"      \Allocate=@"+ClassName+"___Allocate()" )
      WriteStringN(out,"      \CopyObj=@"+ClassName+"___Copy()" )
      WriteStringN(out,"      \Free=@"+ClassName+"___Free()" )
      WriteStringN(out,"      \vt = @vt\pmethods" )
      If class()\extends      
        string=UCase(class()\extends)
        class(UCase(classlist()))
        WriteStringN(out,"      *parent = "+RemoveDoubleColon(ReplaceString(class(string)\name,"::","::__"))+"_Init()" )
        WriteStringN(out,"      \Extends = *parent")
        
        class(UCase(classlist()))
      EndIf
      WriteStringN(out,"      \pUplist = Uplist")  
      
      WriteStringN(out,vt)
      WriteStringN(out,"" )
      
      If class()\extends<>""
        For ii=0 To i-3
          WriteStringN(out,"      \pUplist\pClassInfo["+ii+"] = *parent\pUplist\pClassInfo["+ii+"]")
        Next
        WriteStringN(out,"      \pUplist\pClassInfo["+Str(i-2)+"] = *parent")
      EndIf
      WriteStringN(out,"      \pUplist\pClassInfo["+Str(i-1)+"] = classinfo")
      WriteStringN(out,"      \pUplist\pClassInfo["+i+"] = #Null")
      WriteStringN(out,"    EndWith" )
      WriteStringN(out,"  EndIf")
      WriteStringN(out,"  ProcedureReturn classinfo")
      WriteStringN(out,"EndProcedure")
      WriteStringN(out,";EndDefineClass")
      WriteStringN(out,"")
      
      CloseFile(out)
      
    EndIf
  Next
EndProcedure
; IDE Options = PureBasic 5.61 (MacOS X - x64)
; CursorPosition = 106
; FirstLine = 72
; Folding = --
; EnableXP